(function() {
   'use strict';

   var 
      router = require('router'),
      endecUtil = require('EndecUtil');

   router.get('/', function(req, res) {
      res.json({
         message: 'Hello from GET'
      });
   });

   router.get('/htmlecho/:message', function(req, res) {
      res.send(
         '<p>' + endecUtil.escapeXML(req.params.message) + '</p>'
      );
   });

   router.get('/fail', function(req, res) {
      res.status(418)
         .json({
            message: 'Failed with status code 418'
         });
   });

   router.get('/headers', function(req, res) {
      res.set('Cache-Control', 'no-cache')
         .set('X-Custom-Header', 'Custom header value');

      res.json({
         message: 'Some headers included in response'
      });
   });

   router.get('/myroute', function(req, res) {
      res.json({
         message: 'Hello from myroute GET'
      });
   });

   router.post('/myroute', function(req, res) {
      res.json({
         message: 'Hello from myroute POST'
      });
   });

   router.put('/myroute', function(req, res) {
      res.json({
         message: 'Hello from myroute PUT'
      });
   });

   router['delete']('/myroute', function(req, res) {
      res.json({
         message: 'Hello from myroute DELETE'
      });
   });
}());